package com.ynet.life.loaf;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.data.DataField;
import com.ynet.gene.data.IndexedCollection;
import com.ynet.gene.data.KeyedCollection;
import com.ynet.life.base.Trace;
import com.ynet.life.exception.TranFailException;
import com.ynet.life.loaf.jdbc.DataTypeConfig;
import com.ynet.life.loaf.jdbc.LoafPreparedData;
import com.ynet.life.loaf.jdbc.LoafQueryCondition;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;

/* loaded from: com_ynet_life_loaf.jar:com/ynet/life/loaf/LoafTools.class */
public class LoafTools {
    protected LoafTools() {
    }

    public static void removeLastComma(StringBuffer str) {
        int lastIndex = str.length() - 1;
        if (str.charAt(lastIndex) == ',') {
            str.deleteCharAt(lastIndex);
        }
    }

    public static void fillResultIntoIcoll(TableConfig tableConfig, ResultSet resultSet, IndexedCollection input) throws SQLException {
        input.clear();
        KeyedCollection inputData = input.getDataElement();
        Map dataToTableMap = tableConfig.getDataToTableFieldHashMap();
        while (resultSet.next()) {
            KeyedCollection singleRecord = new KeyedCollection();
            for (String dataFieldName : inputData.keySet()) {
                String tableFieldName = (String) dataToTableMap.get(dataFieldName);
                if (tableFieldName != null) {
                    LoafPreparedData resultData = DataTypeConfig.getData(tableConfig.getTableName(), tableFieldName);
                    resultData.fetchResult(resultSet, tableFieldName);
                    try {
                        singleRecord.addDataField(dataFieldName, resultData.getDataValue());
                    } catch (GENEException empe) {
                        Trace.logError("LOAF", empe.getMessage(), empe);
                    }
                }
            }
            input.addDataElement(singleRecord);
        }
    }

    public static String getPrimaryKey(Context context, String currentBusinessCode) throws TranFailException {
        TableConfig tableConfig = DataMappingProvider.getTableConfig(currentBusinessCode);
        return new LoafQueryCondition(tableConfig, context).toString();
    }

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r0v1 */
    /* JADX WARN: Type inference failed for: r0v16, types: [java.io.ObjectOutputStream] */
    /* JADX WARN: Type inference failed for: r0v5, types: [java.lang.Exception] */
    public static void serial(Object context, String filePath) {
        FileOutputStream fos = null;
        ?? r0 = 0;
        ObjectOutputStream oos = null;
        try {
            try {
                File file = new File(filePath);
                File parent = file.getParentFile();
                if (!parent.exists()) {
                    parent.mkdirs();
                }
                file.createNewFile();
                fos = new FileOutputStream(filePath);
                ObjectOutputStream objectOutputStream = new ObjectOutputStream(fos);
                oos = objectOutputStream;
                objectOutputStream.writeObject(context);
                oos.flush();
                r0 = oos;
                r0.close();
                try {
                    fos.close();
                    oos.close();
                } catch (Exception unused) {
                }
            } catch (Exception e) {
                r0.printStackTrace();
                try {
                    fos.close();
                    oos.close();
                } catch (Exception unused2) {
                }
            }
        } catch (Throwable th) {
            try {
                fos.close();
                oos.close();
            } catch (Exception unused3) {
            }
            throw th;
        }
    }

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r0v15, types: [java.io.ObjectOutputStream] */
    /* JADX WARN: Type inference failed for: r0v2 */
    /* JADX WARN: Type inference failed for: r0v3, types: [java.lang.Exception] */
    public static byte[] serial(Object context) {
        ByteArrayOutputStream bos = null;
        ObjectOutputStream oos = null;
        ?? r0 = 0;
        byte[] bytes = null;
        try {
            try {
                bos = new ByteArrayOutputStream();
                ObjectOutputStream objectOutputStream = new ObjectOutputStream(bos);
                oos = objectOutputStream;
                objectOutputStream.writeObject(context);
                bytes = bos.toByteArray();
                oos.flush();
                r0 = oos;
                r0.close();
                try {
                    bos.close();
                    oos.close();
                } catch (Exception unused) {
                }
            } catch (Throwable th) {
                try {
                    bos.close();
                    oos.close();
                } catch (Exception unused2) {
                }
                throw th;
            }
        } catch (Exception e) {
            r0.printStackTrace();
            try {
                bos.close();
                oos.close();
            } catch (Exception unused3) {
            }
        }
        return bytes;
    }

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r0v12, types: [java.lang.Object] */
    /* JADX WARN: Type inference failed for: r0v2 */
    /* JADX WARN: Type inference failed for: r0v6, types: [java.lang.Exception] */
    public static Object deSerial(byte[] bytes) {
        ByteArrayInputStream bis = null;
        ObjectInputStream ois = null;
        ?? r0 = 0;
        Object object = null;
        try {
            try {
                bis = new ByteArrayInputStream(bytes);
                ObjectInputStream objectInputStream = new ObjectInputStream(bis);
                ois = objectInputStream;
                r0 = objectInputStream.readObject();
                object = r0;
                try {
                    bis.close();
                    ois.close();
                } catch (Exception unused) {
                }
            } catch (Exception e) {
                r0.printStackTrace();
                try {
                    bis.close();
                    ois.close();
                } catch (Exception unused2) {
                }
            }
            return object;
        } catch (Throwable th) {
            try {
                bis.close();
                ois.close();
            } catch (Exception unused3) {
            }
            throw th;
        }
    }

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r0v12, types: [java.lang.Object] */
    /* JADX WARN: Type inference failed for: r0v2 */
    /* JADX WARN: Type inference failed for: r0v6, types: [java.lang.Exception] */
    public static Object deSerial(String filePath) {
        FileInputStream fis = null;
        ObjectInputStream ois = null;
        ?? r0 = 0;
        Object object = null;
        try {
            try {
                fis = new FileInputStream(filePath);
                ObjectInputStream objectInputStream = new ObjectInputStream(fis);
                ois = objectInputStream;
                r0 = objectInputStream.readObject();
                object = r0;
                try {
                    fis.close();
                    ois.close();
                } catch (Exception unused) {
                }
            } catch (Exception e) {
                r0.printStackTrace();
                try {
                    fis.close();
                    ois.close();
                } catch (Exception unused2) {
                }
            }
            return object;
        } catch (Throwable th) {
            try {
                fis.close();
                ois.close();
            } catch (Exception unused3) {
            }
            throw th;
        }
    }

    public static String preProcessSql(Context context, String preparedSQL, List originInput, List finalInput) {
        StringBuffer processedSQL = new StringBuffer(preparedSQL);
        int scanPos = 0;
        Iterator iterator = originInput.iterator();
        while (iterator.hasNext()) {
            try {
                String fieldName = (String) iterator.next();
                String inputValue = (String) context.getDataValue(fieldName);
                int matchPos = processedSQL.indexOf("?", scanPos);
                if (matchPos > 0) {
                    scanPos = matchPos + 1;
                    if (" is".equalsIgnoreCase(processedSQL.substring(scanPos, scanPos + 3))) {
                        String replaceString = (inputValue == null || inputValue.length() == 0) ? "NULL" : "1";
                        processedSQL.replace(matchPos, matchPos + 1, replaceString);
                    } else {
                        finalInput.add(inputValue);
                    }
                }
            } catch (GENEException empe) {
                Trace.logError("LOAF", empe.getMessage(), empe);
            }
        }
        return processedSQL.toString();
    }

    public static String parseQuerySql(Context context, String querySql, List inputFields) {
        Matcher m = LoafConstants.PATTERN_INPUT_FIELD.matcher(querySql);
        StringBuffer sb = new StringBuffer();
        String replacement = null;
        String icollFieldName = null;
        boolean hasParseParam = false;
        while (m.find()) {
            hasParseParam = true;
            String inClause = m.group(1);
            String paramName = m.group(2);
            String isClause = m.group(3);
            String substring = paramName.substring(1);
            String fieldName = substring;
            int dotPosition = substring.indexOf(46);
            if (dotPosition > 0) {
                icollFieldName = fieldName.substring(dotPosition + 1);
                fieldName = fieldName.substring(0, dotPosition);
            }
            Object dataElement = context.get(fieldName);
            if (isClause != null && isClause.length() > 0) {
                if (dataElement == null || (((dataElement instanceof String) && ((String) dataElement).length() == 0) || ((dataElement instanceof IndexedCollection) && ((IndexedCollection) dataElement).size() == 0))) {
                    replacement = "NULL";
                } else {
                    replacement = "1";
                }
            } else if (inClause != null && inClause.length() > 0) {
                if (dataElement == null) {
                    replacement = "('1')";
                } else if (dataElement instanceof IndexedCollection) {
                    IndexedCollection icoll = (IndexedCollection) dataElement;
                    if (icoll.size() == 0) {
                        replacement = "('1')";
                    } else {
                        StringBuffer tempBuffer = new StringBuffer("(");
                        for (int i = 0; i < icoll.size(); i++) {
                            try {
                                tempBuffer.append("?,");
                                KeyedCollection kcoll = icoll.getElementAt(i);
                                if (icollFieldName != null && icollFieldName.length() > 0) {
                                    inputFields.add(kcoll.get(icollFieldName));
                                } else {
                                    DataField dataField = kcoll.getDataElement(0);
                                    inputFields.add(dataField.getValue());
                                }
                            } catch (Exception unused) {
                            }
                        }
                        tempBuffer.deleteCharAt(tempBuffer.length() - 1);
                        tempBuffer.append(")");
                        replacement = tempBuffer.toString();
                    }
                } else if (dataElement instanceof String) {
                    replacement = "(?)";
                    inputFields.add(dataElement);
                }
            } else {
                replacement = "?";
                inputFields.add(dataElement);
            }
            if (inClause != null && inClause.length() > 0) {
                replacement = String.valueOf(inClause) + replacement;
            }
            if (isClause != null && isClause.length() > 0) {
                replacement = String.valueOf(replacement) + isClause;
            }
            m.appendReplacement(sb, replacement);
        }
        if (!hasParseParam) {
            return querySql;
        }
        m.appendTail(sb);
        return sb.toString();
    }

    public static void addICollField(Map context, TableConfig tableConfig) {
        String iCollName = LOAFHelper.getICollName(tableConfig);
        if (iCollName != null && iCollName.length() > 0) {
            HashMap hashMap = new HashMap();
            for (String fieldName : context.keySet()) {
                String fieldValue = (String) context.get(fieldName);
                String iCollFieldName = String.valueOf(iCollName) + LoafConstants.ICOLL_FIELD_SEPARATOR + fieldName;
                if (tableConfig.getContextFieldMap().containsKey(iCollFieldName)) {
                    hashMap.put(iCollFieldName, fieldValue);
                }
            }
            context.putAll(hashMap);
        }
    }

    public static void addContextFieldToIColl(Map context, TableConfig tableConfig, Map icollContext) {
        for (Map.Entry entry : tableConfig.getContextFieldMap().entrySet()) {
            String dataField = (String) entry.getKey();
            String contextField = (String) entry.getValue();
            if (contextField != null) {
                icollContext.put(dataField, context.get(contextField));
            }
        }
        String icollName = LOAFHelper.getICollName(tableConfig);
        for (String dataField2 : tableConfig.getDataToTableFieldHashMap().keySet()) {
            if (dataField2.indexOf(String.valueOf(icollName) + LoafConstants.ICOLL_FIELD_SEPARATOR) < 0) {
                icollContext.put(dataField2, context.get(dataField2));
            }
        }
    }
}
